Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest/Makefile.mkf
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest/Makefile.mkf	(revision 62)
+++ 	(revision )
@@ -1,144 +1,0 @@
-#
-# Makefile generated by MKF configure script
-#
-
-all: RegisterFile_Multi_Banked_0.ngc RegisterFile_Multi_Banked_1.ngc RegisterFile_Multi_Banked_2.ngc RegisterFile_Multi_Banked_3.ngc RegisterFile_Multi_Banked_4.ngc RegisterFile_Multi_Banked_5.ngc
-
-RegisterFile_Multi_Banked_0.ngc: RegisterFile_Multi_Banked_0.prj
-	echo run -keep_hierarchy yes -iobuf no -top RegisterFile_Multi_Banked_0 -ifn RegisterFile_Multi_Banked_0.prj -ofn RegisterFile_Multi_Banked_0.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-RegisterFile_Multi_Banked_0.prj: RegisterFile_Multi_Banked_0_bank_Pack.vhdl RegisterFile_Multi_Banked_0_bank.vhdl RegisterFile_Multi_Banked_0_Pack.vhdl RegisterFile_Multi_Banked_0_select_4_ports_Pack.vhdl RegisterFile_Multi_Banked_0_select_4_ports.vhdl RegisterFile_Multi_Banked_0.vhdl
-	for i in RegisterFile_Multi_Banked_0_bank_Pack.vhdl RegisterFile_Multi_Banked_0_bank.vhdl RegisterFile_Multi_Banked_0_Pack.vhdl RegisterFile_Multi_Banked_0_select_4_ports_Pack.vhdl RegisterFile_Multi_Banked_0_select_4_ports.vhdl RegisterFile_Multi_Banked_0.vhdl ; do echo "vhdl work $$i" ; done > RegisterFile_Multi_Banked_0.prj
-
-RegisterFile_Multi_Banked_0_bank_Pack.vhdl:
-
-RegisterFile_Multi_Banked_0_bank.vhdl:
-
-RegisterFile_Multi_Banked_0_Pack.vhdl:
-
-RegisterFile_Multi_Banked_0_select_4_ports_Pack.vhdl:
-
-RegisterFile_Multi_Banked_0_select_4_ports.vhdl:
-
-RegisterFile_Multi_Banked_0.vhdl:
-
-RegisterFile_Multi_Banked_1.ngc: RegisterFile_Multi_Banked_1.prj
-	echo run -keep_hierarchy yes -iobuf no -top RegisterFile_Multi_Banked_1 -ifn RegisterFile_Multi_Banked_1.prj -ofn RegisterFile_Multi_Banked_1.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-RegisterFile_Multi_Banked_1.prj: RegisterFile_Multi_Banked_1_bank_Pack.vhdl RegisterFile_Multi_Banked_1_bank.vhdl RegisterFile_Multi_Banked_1_Pack.vhdl RegisterFile_Multi_Banked_1_select_4_ports_Pack.vhdl RegisterFile_Multi_Banked_1_select_4_ports.vhdl RegisterFile_Multi_Banked_1.vhdl
-	for i in RegisterFile_Multi_Banked_1_bank_Pack.vhdl RegisterFile_Multi_Banked_1_bank.vhdl RegisterFile_Multi_Banked_1_Pack.vhdl RegisterFile_Multi_Banked_1_select_4_ports_Pack.vhdl RegisterFile_Multi_Banked_1_select_4_ports.vhdl RegisterFile_Multi_Banked_1.vhdl ; do echo "vhdl work $$i" ; done > RegisterFile_Multi_Banked_1.prj
-
-RegisterFile_Multi_Banked_1_bank_Pack.vhdl:
-
-RegisterFile_Multi_Banked_1_bank.vhdl:
-
-RegisterFile_Multi_Banked_1_Pack.vhdl:
-
-RegisterFile_Multi_Banked_1_select_4_ports_Pack.vhdl:
-
-RegisterFile_Multi_Banked_1_select_4_ports.vhdl:
-
-RegisterFile_Multi_Banked_1.vhdl:
-
-RegisterFile_Multi_Banked_2.ngc: RegisterFile_Multi_Banked_2.prj
-	echo run -keep_hierarchy yes -iobuf no -top RegisterFile_Multi_Banked_2 -ifn RegisterFile_Multi_Banked_2.prj -ofn RegisterFile_Multi_Banked_2.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-RegisterFile_Multi_Banked_2.prj: RegisterFile_Multi_Banked_2_bank_Pack.vhdl RegisterFile_Multi_Banked_2_bank.vhdl RegisterFile_Multi_Banked_2_Pack.vhdl RegisterFile_Multi_Banked_2_select_4_ports_Pack.vhdl RegisterFile_Multi_Banked_2_select_4_ports.vhdl RegisterFile_Multi_Banked_2.vhdl
-	for i in RegisterFile_Multi_Banked_2_bank_Pack.vhdl RegisterFile_Multi_Banked_2_bank.vhdl RegisterFile_Multi_Banked_2_Pack.vhdl RegisterFile_Multi_Banked_2_select_4_ports_Pack.vhdl RegisterFile_Multi_Banked_2_select_4_ports.vhdl RegisterFile_Multi_Banked_2.vhdl ; do echo "vhdl work $$i" ; done > RegisterFile_Multi_Banked_2.prj
-
-RegisterFile_Multi_Banked_2_bank_Pack.vhdl:
-
-RegisterFile_Multi_Banked_2_bank.vhdl:
-
-RegisterFile_Multi_Banked_2_Pack.vhdl:
-
-RegisterFile_Multi_Banked_2_select_4_ports_Pack.vhdl:
-
-RegisterFile_Multi_Banked_2_select_4_ports.vhdl:
-
-RegisterFile_Multi_Banked_2.vhdl:
-
-RegisterFile_Multi_Banked_3.ngc: RegisterFile_Multi_Banked_3.prj
-	echo run -keep_hierarchy yes -iobuf no -top RegisterFile_Multi_Banked_3 -ifn RegisterFile_Multi_Banked_3.prj -ofn RegisterFile_Multi_Banked_3.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-RegisterFile_Multi_Banked_3.prj: RegisterFile_Multi_Banked_3_bank_Pack.vhdl RegisterFile_Multi_Banked_3_bank.vhdl RegisterFile_Multi_Banked_3_Pack.vhdl RegisterFile_Multi_Banked_3_select_8_ports_Pack.vhdl RegisterFile_Multi_Banked_3_select_8_ports.vhdl RegisterFile_Multi_Banked_3.vhdl
-	for i in RegisterFile_Multi_Banked_3_bank_Pack.vhdl RegisterFile_Multi_Banked_3_bank.vhdl RegisterFile_Multi_Banked_3_Pack.vhdl RegisterFile_Multi_Banked_3_select_8_ports_Pack.vhdl RegisterFile_Multi_Banked_3_select_8_ports.vhdl RegisterFile_Multi_Banked_3.vhdl ; do echo "vhdl work $$i" ; done > RegisterFile_Multi_Banked_3.prj
-
-RegisterFile_Multi_Banked_3_bank_Pack.vhdl:
-
-RegisterFile_Multi_Banked_3_bank.vhdl:
-
-RegisterFile_Multi_Banked_3_Pack.vhdl:
-
-RegisterFile_Multi_Banked_3_select_8_ports_Pack.vhdl:
-
-RegisterFile_Multi_Banked_3_select_8_ports.vhdl:
-
-RegisterFile_Multi_Banked_3.vhdl:
-
-RegisterFile_Multi_Banked_4.ngc: RegisterFile_Multi_Banked_4.prj
-	echo run -keep_hierarchy yes -iobuf no -top RegisterFile_Multi_Banked_4 -ifn RegisterFile_Multi_Banked_4.prj -ofn RegisterFile_Multi_Banked_4.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-RegisterFile_Multi_Banked_4.prj: RegisterFile_Multi_Banked_4_bank_Pack.vhdl RegisterFile_Multi_Banked_4_bank.vhdl RegisterFile_Multi_Banked_4_Pack.vhdl RegisterFile_Multi_Banked_4_select_8_ports_Pack.vhdl RegisterFile_Multi_Banked_4_select_8_ports.vhdl RegisterFile_Multi_Banked_4.vhdl
-	for i in RegisterFile_Multi_Banked_4_bank_Pack.vhdl RegisterFile_Multi_Banked_4_bank.vhdl RegisterFile_Multi_Banked_4_Pack.vhdl RegisterFile_Multi_Banked_4_select_8_ports_Pack.vhdl RegisterFile_Multi_Banked_4_select_8_ports.vhdl RegisterFile_Multi_Banked_4.vhdl ; do echo "vhdl work $$i" ; done > RegisterFile_Multi_Banked_4.prj
-
-RegisterFile_Multi_Banked_4_bank_Pack.vhdl:
-
-RegisterFile_Multi_Banked_4_bank.vhdl:
-
-RegisterFile_Multi_Banked_4_Pack.vhdl:
-
-RegisterFile_Multi_Banked_4_select_8_ports_Pack.vhdl:
-
-RegisterFile_Multi_Banked_4_select_8_ports.vhdl:
-
-RegisterFile_Multi_Banked_4.vhdl:
-
-RegisterFile_Multi_Banked_5.ngc: RegisterFile_Multi_Banked_5.prj
-	echo run -keep_hierarchy yes -iobuf no -top RegisterFile_Multi_Banked_5 -ifn RegisterFile_Multi_Banked_5.prj -ofn RegisterFile_Multi_Banked_5.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-RegisterFile_Multi_Banked_5.prj: RegisterFile_Multi_Banked_5_bank_Pack.vhdl RegisterFile_Multi_Banked_5_bank.vhdl RegisterFile_Multi_Banked_5_Pack.vhdl RegisterFile_Multi_Banked_5_select_8_ports_Pack.vhdl RegisterFile_Multi_Banked_5_select_8_ports.vhdl RegisterFile_Multi_Banked_5.vhdl
-	for i in RegisterFile_Multi_Banked_5_bank_Pack.vhdl RegisterFile_Multi_Banked_5_bank.vhdl RegisterFile_Multi_Banked_5_Pack.vhdl RegisterFile_Multi_Banked_5_select_8_ports_Pack.vhdl RegisterFile_Multi_Banked_5_select_8_ports.vhdl RegisterFile_Multi_Banked_5.vhdl ; do echo "vhdl work $$i" ; done > RegisterFile_Multi_Banked_5.prj
-
-RegisterFile_Multi_Banked_5_bank_Pack.vhdl:
-
-RegisterFile_Multi_Banked_5_bank.vhdl:
-
-RegisterFile_Multi_Banked_5_Pack.vhdl:
-
-RegisterFile_Multi_Banked_5_select_8_ports_Pack.vhdl:
-
-RegisterFile_Multi_Banked_5_select_8_ports.vhdl:
-
-RegisterFile_Multi_Banked_5.vhdl:
-
-clean:
-	rm -f RegisterFile_Multi_Banked_0.ngc
-	rm -f RegisterFile_Multi_Banked_0.lso
-	rm -f -r xst
-	rm -f RegisterFile_Multi_Banked_0.prj
-	rm -f RegisterFile_Multi_Banked_1.ngc
-	rm -f RegisterFile_Multi_Banked_1.lso
-	rm -f -r xst
-	rm -f RegisterFile_Multi_Banked_1.prj
-	rm -f RegisterFile_Multi_Banked_2.ngc
-	rm -f RegisterFile_Multi_Banked_2.lso
-	rm -f -r xst
-	rm -f RegisterFile_Multi_Banked_2.prj
-	rm -f RegisterFile_Multi_Banked_3.ngc
-	rm -f RegisterFile_Multi_Banked_3.lso
-	rm -f -r xst
-	rm -f RegisterFile_Multi_Banked_3.prj
-	rm -f RegisterFile_Multi_Banked_4.ngc
-	rm -f RegisterFile_Multi_Banked_4.lso
-	rm -f -r xst
-	rm -f RegisterFile_Multi_Banked_4.prj
-	rm -f RegisterFile_Multi_Banked_5.ngc
-	rm -f RegisterFile_Multi_Banked_5.lso
-	rm -f -r xst
-	rm -f RegisterFile_Multi_Banked_5.prj
-
-re: clean all
-
-install:
-
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/Makefile.mkf
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/Makefile.mkf	(revision 62)
+++ 	(revision )
@@ -1,180 +1,0 @@
-#
-# Makefile generated by MKF configure script
-#
-
-all: Select_Priority_Fixed_0.ngc Select_Priority_Fixed_10.ngc Select_Priority_Fixed_11.ngc Select_Priority_Fixed_1.ngc Select_Priority_Fixed_2.ngc Select_Priority_Fixed_3.ngc Select_Priority_Fixed_4.ngc Select_Priority_Fixed_5.ngc Select_Priority_Fixed_6.ngc Select_Priority_Fixed_7.ngc Select_Priority_Fixed_8.ngc Select_Priority_Fixed_9.ngc
-
-Select_Priority_Fixed_0.ngc: Select_Priority_Fixed_0.prj
-	echo run -keep_hierarchy yes -iobuf no -top Select_Priority_Fixed_0 -ifn Select_Priority_Fixed_0.prj -ofn Select_Priority_Fixed_0.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-Select_Priority_Fixed_0.prj: Select_Priority_Fixed_0_Pack.vhdl Select_Priority_Fixed_0.vhdl
-	for i in Select_Priority_Fixed_0_Pack.vhdl Select_Priority_Fixed_0.vhdl ; do echo "vhdl work $$i" ; done > Select_Priority_Fixed_0.prj
-
-Select_Priority_Fixed_0_Pack.vhdl:
-
-Select_Priority_Fixed_0.vhdl:
-
-Select_Priority_Fixed_10.ngc: Select_Priority_Fixed_10.prj
-	echo run -keep_hierarchy yes -iobuf no -top Select_Priority_Fixed_10 -ifn Select_Priority_Fixed_10.prj -ofn Select_Priority_Fixed_10.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-Select_Priority_Fixed_10.prj: Select_Priority_Fixed_10_Pack.vhdl Select_Priority_Fixed_10.vhdl
-	for i in Select_Priority_Fixed_10_Pack.vhdl Select_Priority_Fixed_10.vhdl ; do echo "vhdl work $$i" ; done > Select_Priority_Fixed_10.prj
-
-Select_Priority_Fixed_10_Pack.vhdl:
-
-Select_Priority_Fixed_10.vhdl:
-
-Select_Priority_Fixed_11.ngc: Select_Priority_Fixed_11.prj
-	echo run -keep_hierarchy yes -iobuf no -top Select_Priority_Fixed_11 -ifn Select_Priority_Fixed_11.prj -ofn Select_Priority_Fixed_11.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-Select_Priority_Fixed_11.prj: Select_Priority_Fixed_11_Pack.vhdl Select_Priority_Fixed_11.vhdl
-	for i in Select_Priority_Fixed_11_Pack.vhdl Select_Priority_Fixed_11.vhdl ; do echo "vhdl work $$i" ; done > Select_Priority_Fixed_11.prj
-
-Select_Priority_Fixed_11_Pack.vhdl:
-
-Select_Priority_Fixed_11.vhdl:
-
-Select_Priority_Fixed_1.ngc: Select_Priority_Fixed_1.prj
-	echo run -keep_hierarchy yes -iobuf no -top Select_Priority_Fixed_1 -ifn Select_Priority_Fixed_1.prj -ofn Select_Priority_Fixed_1.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-Select_Priority_Fixed_1.prj: Select_Priority_Fixed_10_Pack.vhdl Select_Priority_Fixed_10.vhdl Select_Priority_Fixed_11_Pack.vhdl Select_Priority_Fixed_11.vhdl Select_Priority_Fixed_1_Pack.vhdl Select_Priority_Fixed_1.vhdl
-	for i in Select_Priority_Fixed_10_Pack.vhdl Select_Priority_Fixed_10.vhdl Select_Priority_Fixed_11_Pack.vhdl Select_Priority_Fixed_11.vhdl Select_Priority_Fixed_1_Pack.vhdl Select_Priority_Fixed_1.vhdl ; do echo "vhdl work $$i" ; done > Select_Priority_Fixed_1.prj
-
-Select_Priority_Fixed_1_Pack.vhdl:
-
-Select_Priority_Fixed_1.vhdl:
-
-Select_Priority_Fixed_2.ngc: Select_Priority_Fixed_2.prj
-	echo run -keep_hierarchy yes -iobuf no -top Select_Priority_Fixed_2 -ifn Select_Priority_Fixed_2.prj -ofn Select_Priority_Fixed_2.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-Select_Priority_Fixed_2.prj: Select_Priority_Fixed_2_Pack.vhdl Select_Priority_Fixed_2.vhdl
-	for i in Select_Priority_Fixed_2_Pack.vhdl Select_Priority_Fixed_2.vhdl ; do echo "vhdl work $$i" ; done > Select_Priority_Fixed_2.prj
-
-Select_Priority_Fixed_2_Pack.vhdl:
-
-Select_Priority_Fixed_2.vhdl:
-
-Select_Priority_Fixed_3.ngc: Select_Priority_Fixed_3.prj
-	echo run -keep_hierarchy yes -iobuf no -top Select_Priority_Fixed_3 -ifn Select_Priority_Fixed_3.prj -ofn Select_Priority_Fixed_3.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-Select_Priority_Fixed_3.prj: Select_Priority_Fixed_3_Pack.vhdl Select_Priority_Fixed_3.vhdl
-	for i in Select_Priority_Fixed_3_Pack.vhdl Select_Priority_Fixed_3.vhdl ; do echo "vhdl work $$i" ; done > Select_Priority_Fixed_3.prj
-
-Select_Priority_Fixed_3_Pack.vhdl:
-
-Select_Priority_Fixed_3.vhdl:
-
-Select_Priority_Fixed_4.ngc: Select_Priority_Fixed_4.prj
-	echo run -keep_hierarchy yes -iobuf no -top Select_Priority_Fixed_4 -ifn Select_Priority_Fixed_4.prj -ofn Select_Priority_Fixed_4.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-Select_Priority_Fixed_4.prj: Select_Priority_Fixed_4_Pack.vhdl Select_Priority_Fixed_4.vhdl
-	for i in Select_Priority_Fixed_4_Pack.vhdl Select_Priority_Fixed_4.vhdl ; do echo "vhdl work $$i" ; done > Select_Priority_Fixed_4.prj
-
-Select_Priority_Fixed_4_Pack.vhdl:
-
-Select_Priority_Fixed_4.vhdl:
-
-Select_Priority_Fixed_5.ngc: Select_Priority_Fixed_5.prj
-	echo run -keep_hierarchy yes -iobuf no -top Select_Priority_Fixed_5 -ifn Select_Priority_Fixed_5.prj -ofn Select_Priority_Fixed_5.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-Select_Priority_Fixed_5.prj: Select_Priority_Fixed_5_Pack.vhdl Select_Priority_Fixed_5.vhdl
-	for i in Select_Priority_Fixed_5_Pack.vhdl Select_Priority_Fixed_5.vhdl ; do echo "vhdl work $$i" ; done > Select_Priority_Fixed_5.prj
-
-Select_Priority_Fixed_5_Pack.vhdl:
-
-Select_Priority_Fixed_5.vhdl:
-
-Select_Priority_Fixed_6.ngc: Select_Priority_Fixed_6.prj
-	echo run -keep_hierarchy yes -iobuf no -top Select_Priority_Fixed_6 -ifn Select_Priority_Fixed_6.prj -ofn Select_Priority_Fixed_6.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-Select_Priority_Fixed_6.prj: Select_Priority_Fixed_6_Pack.vhdl Select_Priority_Fixed_6.vhdl
-	for i in Select_Priority_Fixed_6_Pack.vhdl Select_Priority_Fixed_6.vhdl ; do echo "vhdl work $$i" ; done > Select_Priority_Fixed_6.prj
-
-Select_Priority_Fixed_6_Pack.vhdl:
-
-Select_Priority_Fixed_6.vhdl:
-
-Select_Priority_Fixed_7.ngc: Select_Priority_Fixed_7.prj
-	echo run -keep_hierarchy yes -iobuf no -top Select_Priority_Fixed_7 -ifn Select_Priority_Fixed_7.prj -ofn Select_Priority_Fixed_7.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-Select_Priority_Fixed_7.prj: Select_Priority_Fixed_7_Pack.vhdl Select_Priority_Fixed_7.vhdl
-	for i in Select_Priority_Fixed_7_Pack.vhdl Select_Priority_Fixed_7.vhdl ; do echo "vhdl work $$i" ; done > Select_Priority_Fixed_7.prj
-
-Select_Priority_Fixed_7_Pack.vhdl:
-
-Select_Priority_Fixed_7.vhdl:
-
-Select_Priority_Fixed_8.ngc: Select_Priority_Fixed_8.prj
-	echo run -keep_hierarchy yes -iobuf no -top Select_Priority_Fixed_8 -ifn Select_Priority_Fixed_8.prj -ofn Select_Priority_Fixed_8.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-Select_Priority_Fixed_8.prj: Select_Priority_Fixed_8_Pack.vhdl Select_Priority_Fixed_8.vhdl
-	for i in Select_Priority_Fixed_8_Pack.vhdl Select_Priority_Fixed_8.vhdl ; do echo "vhdl work $$i" ; done > Select_Priority_Fixed_8.prj
-
-Select_Priority_Fixed_8_Pack.vhdl:
-
-Select_Priority_Fixed_8.vhdl:
-
-Select_Priority_Fixed_9.ngc: Select_Priority_Fixed_9.prj
-	echo run -keep_hierarchy yes -iobuf no -top Select_Priority_Fixed_9 -ifn Select_Priority_Fixed_9.prj -ofn Select_Priority_Fixed_9.ngc -p xc5vlx330t-2ff1738 -ifmt mixed | xst
-
-Select_Priority_Fixed_9.prj: Select_Priority_Fixed_9_Pack.vhdl Select_Priority_Fixed_9.vhdl
-	for i in Select_Priority_Fixed_9_Pack.vhdl Select_Priority_Fixed_9.vhdl ; do echo "vhdl work $$i" ; done > Select_Priority_Fixed_9.prj
-
-Select_Priority_Fixed_9_Pack.vhdl:
-
-Select_Priority_Fixed_9.vhdl:
-
-clean:
-	rm -f Select_Priority_Fixed_0.ngc
-	rm -f Select_Priority_Fixed_0.lso
-	rm -f -r xst
-	rm -f Select_Priority_Fixed_0.prj
-	rm -f Select_Priority_Fixed_10.ngc
-	rm -f Select_Priority_Fixed_10.lso
-	rm -f -r xst
-	rm -f Select_Priority_Fixed_10.prj
-	rm -f Select_Priority_Fixed_11.ngc
-	rm -f Select_Priority_Fixed_11.lso
-	rm -f -r xst
-	rm -f Select_Priority_Fixed_11.prj
-	rm -f Select_Priority_Fixed_1.ngc
-	rm -f Select_Priority_Fixed_1.lso
-	rm -f -r xst
-	rm -f Select_Priority_Fixed_1.prj
-	rm -f Select_Priority_Fixed_2.ngc
-	rm -f Select_Priority_Fixed_2.lso
-	rm -f -r xst
-	rm -f Select_Priority_Fixed_2.prj
-	rm -f Select_Priority_Fixed_3.ngc
-	rm -f Select_Priority_Fixed_3.lso
-	rm -f -r xst
-	rm -f Select_Priority_Fixed_3.prj
-	rm -f Select_Priority_Fixed_4.ngc
-	rm -f Select_Priority_Fixed_4.lso
-	rm -f -r xst
-	rm -f Select_Priority_Fixed_4.prj
-	rm -f Select_Priority_Fixed_5.ngc
-	rm -f Select_Priority_Fixed_5.lso
-	rm -f -r xst
-	rm -f Select_Priority_Fixed_5.prj
-	rm -f Select_Priority_Fixed_6.ngc
-	rm -f Select_Priority_Fixed_6.lso
-	rm -f -r xst
-	rm -f Select_Priority_Fixed_6.prj
-	rm -f Select_Priority_Fixed_7.ngc
-	rm -f Select_Priority_Fixed_7.lso
-	rm -f -r xst
-	rm -f Select_Priority_Fixed_7.prj
-	rm -f Select_Priority_Fixed_8.ngc
-	rm -f Select_Priority_Fixed_8.lso
-	rm -f -r xst
-	rm -f Select_Priority_Fixed_8.prj
-	rm -f Select_Priority_Fixed_9.ngc
-	rm -f Select_Priority_Fixed_9.lso
-	rm -f -r xst
-	rm -f Select_Priority_Fixed_9.prj
-
-re: clean all
-
-install:
-